package at.gv.egiz.moazs.config;

import at.gv.egiz.moazs.preprocess.MzsDeliveryRequestValidator;
import at.gv.egiz.moazs.preprocess.*;
import at.gv.zustellung.app2mzs.xsd.ConfigType;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import java.util.Map;

import static at.gv.egiz.moazs.preprocess.ConfigProfileGenerator.configProfileGeneratorBuilder;

@Configuration
public class PreprocessConfig {

    @Bean
    @Autowired
    public Map<String, ConfigType> deliveryRequestConfigs(ConfigProfileGenerator generator) {
        return generator.generate();
    }

    @Bean
    @Autowired
    public ConfigProfileGenerator configProfileGenerator(
            SpringPropertiesFacade properties,
            MzsDeliveryRequestValidator validator,
            ConfigUtil util,
            @Value("${verify-completeness-of-default-delivery-request-configuration:true}")
                    boolean verifyCompletenessOfDefaultConfiguration) {

        return configProfileGeneratorBuilder()
                .withProperties(properties)
                .withConfigUtil(util)
                .withVerifyCompletenessOfDefaultConfiguration(verifyCompletenessOfDefaultConfiguration)
                .withValidator(validator)
                .build();
    }

}
